/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU Lesser General Public License                       */

/* 
 * $Id: arch-freebsd-kernel.h,v 1.3 2002/06/15 15:16:13 mulix Exp $
 */

#ifndef ARCH_FREEBSD_KERNEL_H_
#define ARCH_FREEBSD_KERNEL_H_

#ifndef FREEBSD_KERNEL
#error "arch-freebsd-kernel.h included and FREEBSD_KERNEL not defined!"
#endif

/* malloc/free support */
# include <sys/types.h>
# include <sys/param.h>
# include <sys/malloc.h>

#define mem_alloc(foo) malloc((foo), M_DEVBUF, M_NOWAIT)
#define mem_free(foo)  free((foo), M_DEVBUF)

# define PPRINT(fmt, args...) printf(fmt, ## args)

#endif





