/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU Lesser General Public License                       */

/*
 *$Id: arch-userspace.h,v 1.5 2002/06/15 15:16:13 mulix Exp $
 */
#ifndef ARCH_USERSPACE_H_
#define ARCH_USERSPACE_H_

/* malloc/free support */
# include <malloc.h>
# include <unistd.h>
# include <string.h>
# include <stdio.h>
# include <assert.h>
# include <ctype.h>
# include <stdarg.h>

# define mem_alloc(foo) malloc((foo))
# define mem_free(foo)  free((foo))

/* generic printing macro */
# define PPRINT(fmt, args...) printf(fmt, ## args)

#endif /* ARCH_USERSPACE_H_ */

