/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il	    */
/* License: GNU Lesser General Public License                       */

/*
  *$Id: archdep.h,v 1.3 2002/06/15 15:16:13 mulix Exp $
 */

#ifndef ARCHDEP_H_
#define ARCHDEP_H_

#ifndef sct_min
# define sct_min(a,b) ((a) < (b) ? (a) : (b))
#endif

/* linux kernel support */
#ifdef __KERNEL__

#undef LINX_KERNEL
#define LINUX_KERNEL

#include "arch-linux-kernel.h"

/* freebsd kernel support */
#elif defined _KERNEL

#undef FREEBSD_KERNEL
#define FREEBSD_KERNEL

#include "arch-freebsd-kernel.h"

#else 

/* generic userspace support */
#include "arch-userspace.h"

#endif /* FREEBSD_KERNEL */

/* define these on all platforms if not already defined,
   so that we can use them uncoditionally */

#ifndef KERN_EMERG
#define KERN_EMERG 
#endif /* KERN_EMERG */

#ifndef KERN_ALERT
#define KERN_ALERT 
#endif /* KERN_ALERT */

#ifndef KERN_CRIT
#define KERN_CRIT 
#endif /* KERN_CRIT */

#ifndef KERN_ERR
#define KERN_ERR 
#endif /* KERN_ERR */

#ifndef KERN_WARNING
#define KERN_WARNING 
#endif /* KERN_WARNING */

#ifndef KERN_NOTICE
#define KERN_NOTICE
#endif /* KERN_NOTICE */

#ifndef KERN_INFO
#define KERN_INFO 
#endif /* KERN_INFO */

#ifndef KERN_DEBUG
#define KERN_DEBUG 
#endif /* KERN_DEBUG */

#endif
