/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 Muli Ben-Yehuda, mulix@actcom.co.il      */
/* License: GNU Lesser General Public License                       */

/*
 * $Id: printer.c,v 1.2 2002/06/15 15:16:13 mulix Exp $
 */

/*
 * printer - various printing (logging) support routines
 */

#include "archdep.h"

/* print a DT_BUFFER into a char * buffer (DT_STRING) */ 
/* caller must free returned buffer */ 
char* sct_buffer_to_string(void* buf, size_t bufsz)
{
	unsigned char* ret, *d;  
	unsigned char* s = (char*)buf; 

	if (!buf || !bufsz)
		return NULL; 
	
	ret = d = mem_alloc((bufsz * 4) + 1); /* worst case */ 
	if (!ret)
		return NULL; 

	while (bufsz--) {
		/* if it's an ascii character, put it as itself */ 
		if (isprint(*s))
			*d++ = *s++; 
		else { 
			/* sprintf returns the number of characters */ 
			/* (NOT INCLUDING NULL) outputted to the string */ 
			int charcount = sprintf(d, "\\%u", (unsigned int)*s); 
			d += charcount; 
			s++; 
		}
	}
	*d = '\0'; 
	return ret; 
}
