/* This file is part of syscalltrack, a GNU/Linux kernel module and */
/* user space utilities for logging or modifying any system call    */
/* invocation.                                                      */
/*                                                                  */
/* Copyright (C) 2000-2002 guy keren, choo@actcom.co.il             */
/* License: GNU General Public License                              */

/*
 *$Id: syscall_hijack_public.h,v 1.6 2002/06/17 23:30:34 mulix Exp $
 */

#ifndef _SYSCALL_HIJACK_PUBLIC_H
#define _SYSCALL_HIJACK_PUBLIC_H

/* TODO: fix these to handle different archs properly */
#if defined(__arch_um__) || defined(__i386__)
#define func_ptr unsigned long
#else /* some other arch */ 
#error which arch exactly are you trying to compile syscalltrack for, pray tell?
#endif

/* hijack the given system call.                                         */
/* returns '0' on success, '1' if the syscall is already hijacked, and a */
/* negative int on error. old_function points to the old function on if  */
/* the syscall was hijacked, or to NULL otherwise.                       */
/* NOTE: the 'before' version registers a function that will             */
/* be invoked _before_ the syscall is invoked. the 'after' version       */
/* registers a function that will be invoked _after_ the syscall is      */
/* invoked.                                                              */
int hijack_syscall_before(int syscall_id, func_ptr function);
int hijack_syscall_after(int syscall_id, func_ptr function);

/* releases a previously hijacked system call. */
int release_syscall_before(int syscall_id);
int release_syscall_after(int syscall_id);

#endif /* _SYSCALL_HIJACK_PUBLIC_H */
