/*
 * $Id: tracker_sysctl.h,v 1.3 2002/05/29 12:27:57 mulix Exp $
 */

#ifndef TRACKER_SYSCTL_H_
#define TRACKER_SYSCTL_H_

#include "sct_rules_private.h"
#include "rule_engine_public.h"

int tracker_sysctl_add_rule(int rule_id,
			    sct_rule_when_t when,
			    int syscall_id,
			    int mux_func_id,
			    sct_filter_node_t* f,
			    sct_action_t* a);

int tracker_sysctl_del_rule(int rule_id,
			    sct_rule_when_t when,
			    int syscall_id,
			    int mux_func_id);

/* deletes all existing rules for a given system call. */
/* TODO - handle muxed functions as if they were real syscalls. */
int tracker_sysctl_del_all_rules_for_syscall(int syscall_id, int mux_func_id);

/* deletes all existing rules in the module */
int tracker_sysctl_del_all_module_rules(void);

/* prints all existing rules in the module */
int tracker_sysctl_print_all_rules(void);

/* gets the rule count of all of the rules in the system */ 
int tracker_sysctl_get_all_rule_count(void* oldval, size_t* oldlenp); 

/* get all of the rules in the system, serialized into buffer 'oldval' */
/* which is of size 'oldlenp'. returns 0 on success, and the new size  */
/* of the buffer in oldlenp */  
int tracker_sysctl_get_all_rules(void* oldval, size_t* oldlenp); 

#endif /* TRACKER_SYSCTL_H_ */


