/*
 * $Id: syscall_hijack_autogen.c,v 1.71 2002/06/17 23:30:34 mulix Exp $
 */

/* This file is automatically generated - do not edit. */
/* built by './gen_syscalls.pl 256' for Linux. */


#include <asm/errno.h>

#include <linux/types.h>
#include <linux/time.h>
#include <linux/times.h>
#include <linux/socket.h>
#include <linux/in.h>
#include <linux/utime.h>
#include <linux/utsname.h>
#include <linux/stat.h>
#include <linux/resource.h>
#include <linux/signal.h>
#include <asm/stat.h>
#include <asm/statfs.h>


/* these structures are declared inside the .c file in the kernel, so we copy them here. yuck. */   
struct sel_arg_struct { unsigned long n; fd_set *inp, *outp, *exp; struct timeval *tvp; };
struct mmap_arg_struct { unsigned long addr; unsigned long len; unsigned long prot; unsigned long flags; unsigned long fd; unsigned long offset; };
/*
 * Stub functions for syscall hijacking.
 */

/* stub function for syscall 'read' (3). */
asmlinkage static int
stub_syscall_3(int fd, void* buf, size_t count) {
	typedef int
		(*stub_func_3)(int fd, void* buf, size_t count);
	typedef int
		(*stub_before_func_3)(int fd, void* buf, size_t count, int* syscall_rc); 
	typedef int
		(*stub_after_func_3)(int syscall_rc, int fd, void* buf, size_t count);
	stub_func_3 orig_syscall_func;
	stub_before_func_3 before_func;
	stub_after_func_3 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[3];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_3)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd, buf, count , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_3)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd, buf, count) : -ENOSYS);

	    after_func = (stub_after_func_3)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd, buf, count);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'write' (4). */
asmlinkage static int
stub_syscall_4(int fd, void* buf, size_t count) {
	typedef int
		(*stub_func_4)(int fd, void* buf, size_t count);
	typedef int
		(*stub_before_func_4)(int fd, void* buf, size_t count, int* syscall_rc); 
	typedef int
		(*stub_after_func_4)(int syscall_rc, int fd, void* buf, size_t count);
	stub_func_4 orig_syscall_func;
	stub_before_func_4 before_func;
	stub_after_func_4 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[4];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_4)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd, buf, count , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_4)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd, buf, count) : -ENOSYS);

	    after_func = (stub_after_func_4)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd, buf, count);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'open' (5). */
asmlinkage static int
stub_syscall_5(const char* pathname, int flags, mode_t mode) {
	typedef int
		(*stub_func_5)(const char* pathname, int flags, mode_t mode);
	typedef int
		(*stub_before_func_5)(const char* pathname, int flags, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_5)(int syscall_rc, const char* pathname, int flags, mode_t mode);
	stub_func_5 orig_syscall_func;
	stub_before_func_5 before_func;
	stub_after_func_5 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[5];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_5)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, flags, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_5)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, flags, mode) : -ENOSYS);

	    after_func = (stub_after_func_5)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, flags, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'close' (6). */
asmlinkage static int
stub_syscall_6(int fd) {
	typedef int
		(*stub_func_6)(int fd);
	typedef int
		(*stub_before_func_6)(int fd, int* syscall_rc); 
	typedef int
		(*stub_after_func_6)(int syscall_rc, int fd);
	stub_func_6 orig_syscall_func;
	stub_before_func_6 before_func;
	stub_after_func_6 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[6];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_6)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_6)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd) : -ENOSYS);

	    after_func = (stub_after_func_6)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'waitpid' (7). */
asmlinkage static int
stub_syscall_7(pid_t pid, int* status, int options) {
	typedef int
		(*stub_func_7)(pid_t pid, int* status, int options);
	typedef int
		(*stub_before_func_7)(pid_t pid, int* status, int options, int* syscall_rc); 
	typedef int
		(*stub_after_func_7)(int syscall_rc, pid_t pid, int* status, int options);
	stub_func_7 orig_syscall_func;
	stub_before_func_7 before_func;
	stub_after_func_7 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[7];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_7)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pid, status, options , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_7)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pid, status, options) : -ENOSYS);

	    after_func = (stub_after_func_7)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pid, status, options);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'creat' (8). */
asmlinkage static int
stub_syscall_8(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_8)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_8)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_8)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_8 orig_syscall_func;
	stub_before_func_8 before_func;
	stub_after_func_8 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[8];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_8)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_8)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_8)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'link' (9). */
asmlinkage static int
stub_syscall_9(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_9)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_9)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_9)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_9 orig_syscall_func;
	stub_before_func_9 before_func;
	stub_after_func_9 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[9];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_9)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_9)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_9)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'unlink' (10). */
asmlinkage static int
stub_syscall_10(const char* pathname) {
	typedef int
		(*stub_func_10)(const char* pathname);
	typedef int
		(*stub_before_func_10)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_10)(int syscall_rc, const char* pathname);
	stub_func_10 orig_syscall_func;
	stub_before_func_10 before_func;
	stub_after_func_10 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[10];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_10)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_10)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_10)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'chdir' (12). */
asmlinkage static int
stub_syscall_12(const char* pathname) {
	typedef int
		(*stub_func_12)(const char* pathname);
	typedef int
		(*stub_before_func_12)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_12)(int syscall_rc, const char* pathname);
	stub_func_12 orig_syscall_func;
	stub_before_func_12 before_func;
	stub_after_func_12 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[12];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_12)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_12)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_12)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'time' (13). */
asmlinkage static int
stub_syscall_13(time_t* time) {
	typedef int
		(*stub_func_13)(time_t* time);
	typedef int
		(*stub_before_func_13)(time_t* time, int* syscall_rc); 
	typedef int
		(*stub_after_func_13)(int syscall_rc, time_t* time);
	stub_func_13 orig_syscall_func;
	stub_before_func_13 before_func;
	stub_after_func_13 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[13];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_13)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(time , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_13)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(time) : -ENOSYS);

	    after_func = (stub_after_func_13)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, time);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'mknod' (14). */
asmlinkage static int
stub_syscall_14(const char* pathname, mode_t mode, dev_t dev) {
	typedef int
		(*stub_func_14)(const char* pathname, mode_t mode, dev_t dev);
	typedef int
		(*stub_before_func_14)(const char* pathname, mode_t mode, dev_t dev, int* syscall_rc); 
	typedef int
		(*stub_after_func_14)(int syscall_rc, const char* pathname, mode_t mode, dev_t dev);
	stub_func_14 orig_syscall_func;
	stub_before_func_14 before_func;
	stub_after_func_14 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[14];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_14)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode, dev , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_14)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode, dev) : -ENOSYS);

	    after_func = (stub_after_func_14)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode, dev);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'chmod' (15). */
asmlinkage static int
stub_syscall_15(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_15)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_15)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_15)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_15 orig_syscall_func;
	stub_before_func_15 before_func;
	stub_after_func_15 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[15];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_15)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_15)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_15)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'lchown16' (16). */
asmlinkage static int
stub_syscall_16(const char* filename, unsigned short user, unsigned short group) {
	typedef int
		(*stub_func_16)(const char* filename, unsigned short user, unsigned short group);
	typedef int
		(*stub_before_func_16)(const char* filename, unsigned short user, unsigned short group, int* syscall_rc); 
	typedef int
		(*stub_after_func_16)(int syscall_rc, const char* filename, unsigned short user, unsigned short group);
	stub_func_16 orig_syscall_func;
	stub_before_func_16 before_func;
	stub_after_func_16 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[16];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_16)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(filename, user, group , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_16)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(filename, user, group) : -ENOSYS);

	    after_func = (stub_after_func_16)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, filename, user, group);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'stat' (18). */
asmlinkage static int
stub_syscall_18(const char* file_name, struct __old_kernel_stat* buf) {
	typedef int
		(*stub_func_18)(const char* file_name, struct __old_kernel_stat* buf);
	typedef int
		(*stub_before_func_18)(const char* file_name, struct __old_kernel_stat* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_18)(int syscall_rc, const char* file_name, struct __old_kernel_stat* buf);
	stub_func_18 orig_syscall_func;
	stub_before_func_18 before_func;
	stub_after_func_18 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[18];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_18)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(file_name, buf , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_18)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(file_name, buf) : -ENOSYS);

	    after_func = (stub_after_func_18)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, file_name, buf);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'lseek' (19). */
asmlinkage static int
stub_syscall_19(int fildes, off_t offset, int whence) {
	typedef int
		(*stub_func_19)(int fildes, off_t offset, int whence);
	typedef int
		(*stub_before_func_19)(int fildes, off_t offset, int whence, int* syscall_rc); 
	typedef int
		(*stub_after_func_19)(int syscall_rc, int fildes, off_t offset, int whence);
	stub_func_19 orig_syscall_func;
	stub_before_func_19 before_func;
	stub_after_func_19 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[19];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_19)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fildes, offset, whence , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_19)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fildes, offset, whence) : -ENOSYS);

	    after_func = (stub_after_func_19)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fildes, offset, whence);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getpid' (20). */
asmlinkage static int
stub_syscall_20(void) {
	typedef int
		(*stub_func_20)(void);
	typedef int
		(*stub_before_func_20)(int* syscall_rc); 
	typedef int
		(*stub_after_func_20)(int syscall_rc);
	stub_func_20 orig_syscall_func;
	stub_before_func_20 before_func;
	stub_after_func_20 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[20];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_20)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_20)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_20)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'mount' (21). */
asmlinkage static int
stub_syscall_21(const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data) {
	typedef int
		(*stub_func_21)(const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data);
	typedef int
		(*stub_before_func_21)(const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data, int* syscall_rc); 
	typedef int
		(*stub_after_func_21)(int syscall_rc, const char* source, const char* target, const char* filesystemtype, unsigned long mountflags, void* data);
	stub_func_21 orig_syscall_func;
	stub_before_func_21 before_func;
	stub_after_func_21 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[21];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_21)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(source, target, filesystemtype, mountflags, data , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_21)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(source, target, filesystemtype, mountflags, data) : -ENOSYS);

	    after_func = (stub_after_func_21)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, source, target, filesystemtype, mountflags, data);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'oldumount' (22). */
asmlinkage static int
stub_syscall_22(char* name) {
	typedef int
		(*stub_func_22)(char* name);
	typedef int
		(*stub_before_func_22)(char* name, int* syscall_rc); 
	typedef int
		(*stub_after_func_22)(int syscall_rc, char* name);
	stub_func_22 orig_syscall_func;
	stub_before_func_22 before_func;
	stub_after_func_22 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[22];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_22)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(name , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_22)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(name) : -ENOSYS);

	    after_func = (stub_after_func_22)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, name);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setuid16' (23). */
asmlinkage static int
stub_syscall_23(unsigned short uid) {
	typedef int
		(*stub_func_23)(unsigned short uid);
	typedef int
		(*stub_before_func_23)(unsigned short uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_23)(int syscall_rc, unsigned short uid);
	stub_func_23 orig_syscall_func;
	stub_before_func_23 before_func;
	stub_after_func_23 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[23];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_23)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(uid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_23)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(uid) : -ENOSYS);

	    after_func = (stub_after_func_23)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, uid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getuid16' (24). */
asmlinkage static int
stub_syscall_24(unsigned short gid) {
	typedef int
		(*stub_func_24)(unsigned short gid);
	typedef int
		(*stub_before_func_24)(unsigned short gid, int* syscall_rc); 
	typedef int
		(*stub_after_func_24)(int syscall_rc, unsigned short gid);
	stub_func_24 orig_syscall_func;
	stub_before_func_24 before_func;
	stub_after_func_24 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[24];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_24)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(gid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_24)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(gid) : -ENOSYS);

	    after_func = (stub_after_func_24)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, gid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'stime' (25). */
asmlinkage static int
stub_syscall_25(time_t* time) {
	typedef int
		(*stub_func_25)(time_t* time);
	typedef int
		(*stub_before_func_25)(time_t* time, int* syscall_rc); 
	typedef int
		(*stub_after_func_25)(int syscall_rc, time_t* time);
	stub_func_25 orig_syscall_func;
	stub_before_func_25 before_func;
	stub_after_func_25 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[25];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_25)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(time , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_25)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(time) : -ENOSYS);

	    after_func = (stub_after_func_25)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, time);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'alarm' (27). */
asmlinkage static int
stub_syscall_27(unsigned int seconds) {
	typedef int
		(*stub_func_27)(unsigned int seconds);
	typedef int
		(*stub_before_func_27)(unsigned int seconds, int* syscall_rc); 
	typedef int
		(*stub_after_func_27)(int syscall_rc, unsigned int seconds);
	stub_func_27 orig_syscall_func;
	stub_before_func_27 before_func;
	stub_after_func_27 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[27];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_27)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(seconds , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_27)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(seconds) : -ENOSYS);

	    after_func = (stub_after_func_27)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, seconds);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'fstat' (28). */
asmlinkage static int
stub_syscall_28(int filedes, struct __old_kernel_stat* buf) {
	typedef int
		(*stub_func_28)(int filedes, struct __old_kernel_stat* buf);
	typedef int
		(*stub_before_func_28)(int filedes, struct __old_kernel_stat* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_28)(int syscall_rc, int filedes, struct __old_kernel_stat* buf);
	stub_func_28 orig_syscall_func;
	stub_before_func_28 before_func;
	stub_after_func_28 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[28];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_28)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(filedes, buf , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_28)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(filedes, buf) : -ENOSYS);

	    after_func = (stub_after_func_28)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, filedes, buf);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'pause' (29). */
asmlinkage static int
stub_syscall_29(void) {
	typedef int
		(*stub_func_29)(void);
	typedef int
		(*stub_before_func_29)(int* syscall_rc); 
	typedef int
		(*stub_after_func_29)(int syscall_rc);
	stub_func_29 orig_syscall_func;
	stub_before_func_29 before_func;
	stub_after_func_29 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[29];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_29)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_29)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_29)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'utime' (30). */
asmlinkage static int
stub_syscall_30(const char* filename, struct utimbuf* buf) {
	typedef int
		(*stub_func_30)(const char* filename, struct utimbuf* buf);
	typedef int
		(*stub_before_func_30)(const char* filename, struct utimbuf* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_30)(int syscall_rc, const char* filename, struct utimbuf* buf);
	stub_func_30 orig_syscall_func;
	stub_before_func_30 before_func;
	stub_after_func_30 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[30];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_30)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(filename, buf , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_30)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(filename, buf) : -ENOSYS);

	    after_func = (stub_after_func_30)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, filename, buf);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'access' (33). */
asmlinkage static int
stub_syscall_33(const char* pathname, int mode) {
	typedef int
		(*stub_func_33)(const char* pathname, int mode);
	typedef int
		(*stub_before_func_33)(const char* pathname, int mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_33)(int syscall_rc, const char* pathname, int mode);
	stub_func_33 orig_syscall_func;
	stub_before_func_33 before_func;
	stub_after_func_33 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[33];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_33)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_33)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_33)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'nice' (34). */
asmlinkage static int
stub_syscall_34(int inc) {
	typedef int
		(*stub_func_34)(int inc);
	typedef int
		(*stub_before_func_34)(int inc, int* syscall_rc); 
	typedef int
		(*stub_after_func_34)(int syscall_rc, int inc);
	stub_func_34 orig_syscall_func;
	stub_before_func_34 before_func;
	stub_after_func_34 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[34];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_34)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(inc , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_34)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(inc) : -ENOSYS);

	    after_func = (stub_after_func_34)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, inc);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'sync' (36). */
asmlinkage static int
stub_syscall_36(void) {
	typedef int
		(*stub_func_36)(void);
	typedef int
		(*stub_before_func_36)(int* syscall_rc); 
	typedef int
		(*stub_after_func_36)(int syscall_rc);
	stub_func_36 orig_syscall_func;
	stub_before_func_36 before_func;
	stub_after_func_36 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[36];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_36)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_36)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_36)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'kill' (37). */
asmlinkage static int
stub_syscall_37(pid_t pid, int sig) {
	typedef int
		(*stub_func_37)(pid_t pid, int sig);
	typedef int
		(*stub_before_func_37)(pid_t pid, int sig, int* syscall_rc); 
	typedef int
		(*stub_after_func_37)(int syscall_rc, pid_t pid, int sig);
	stub_func_37 orig_syscall_func;
	stub_before_func_37 before_func;
	stub_after_func_37 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[37];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_37)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pid, sig , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_37)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pid, sig) : -ENOSYS);

	    after_func = (stub_after_func_37)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pid, sig);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'rename' (38). */
asmlinkage static int
stub_syscall_38(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_38)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_38)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_38)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_38 orig_syscall_func;
	stub_before_func_38 before_func;
	stub_after_func_38 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[38];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_38)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_38)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_38)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'mkdir' (39). */
asmlinkage static int
stub_syscall_39(const char* pathname, mode_t mode) {
	typedef int
		(*stub_func_39)(const char* pathname, mode_t mode);
	typedef int
		(*stub_before_func_39)(const char* pathname, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_39)(int syscall_rc, const char* pathname, mode_t mode);
	stub_func_39 orig_syscall_func;
	stub_before_func_39 before_func;
	stub_after_func_39 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[39];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_39)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_39)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname, mode) : -ENOSYS);

	    after_func = (stub_after_func_39)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'rmdir' (40). */
asmlinkage static int
stub_syscall_40(const char* pathname) {
	typedef int
		(*stub_func_40)(const char* pathname);
	typedef int
		(*stub_before_func_40)(const char* pathname, int* syscall_rc); 
	typedef int
		(*stub_after_func_40)(int syscall_rc, const char* pathname);
	stub_func_40 orig_syscall_func;
	stub_before_func_40 before_func;
	stub_after_func_40 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[40];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_40)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pathname , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_40)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pathname) : -ENOSYS);

	    after_func = (stub_after_func_40)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pathname);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'dup' (41). */
asmlinkage static int
stub_syscall_41(int oldfd) {
	typedef int
		(*stub_func_41)(int oldfd);
	typedef int
		(*stub_before_func_41)(int oldfd, int* syscall_rc); 
	typedef int
		(*stub_after_func_41)(int syscall_rc, int oldfd);
	stub_func_41 orig_syscall_func;
	stub_before_func_41 before_func;
	stub_after_func_41 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[41];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_41)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldfd , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_41)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldfd) : -ENOSYS);

	    after_func = (stub_after_func_41)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldfd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'pipe' (42). */
asmlinkage static int
stub_syscall_42(int filedes[2]) {
	typedef int
		(*stub_func_42)(int filedes[2]);
	typedef int
		(*stub_before_func_42)(int filedes[2], int* syscall_rc); 
	typedef int
		(*stub_after_func_42)(int syscall_rc, int filedes[2]);
	stub_func_42 orig_syscall_func;
	stub_before_func_42 before_func;
	stub_after_func_42 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[42];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_42)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(filedes , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_42)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(filedes) : -ENOSYS);

	    after_func = (stub_after_func_42)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, filedes);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'times' (43). */
asmlinkage static int
stub_syscall_43(struct tms* buf) {
	typedef int
		(*stub_func_43)(struct tms* buf);
	typedef int
		(*stub_before_func_43)(struct tms* buf, int* syscall_rc); 
	typedef int
		(*stub_after_func_43)(int syscall_rc, struct tms* buf);
	stub_func_43 orig_syscall_func;
	stub_before_func_43 before_func;
	stub_after_func_43 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[43];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_43)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(buf , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_43)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(buf) : -ENOSYS);

	    after_func = (stub_after_func_43)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, buf);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'brk' (45). */
asmlinkage static int
stub_syscall_45(void* end_data_segment) {
	typedef int
		(*stub_func_45)(void* end_data_segment);
	typedef int
		(*stub_before_func_45)(void* end_data_segment, int* syscall_rc); 
	typedef int
		(*stub_after_func_45)(int syscall_rc, void* end_data_segment);
	stub_func_45 orig_syscall_func;
	stub_before_func_45 before_func;
	stub_after_func_45 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[45];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_45)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(end_data_segment , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_45)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(end_data_segment) : -ENOSYS);

	    after_func = (stub_after_func_45)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, end_data_segment);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setgid16' (46). */
asmlinkage static int
stub_syscall_46(unsigned short uid) {
	typedef int
		(*stub_func_46)(unsigned short uid);
	typedef int
		(*stub_before_func_46)(unsigned short uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_46)(int syscall_rc, unsigned short uid);
	stub_func_46 orig_syscall_func;
	stub_before_func_46 before_func;
	stub_after_func_46 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[46];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_46)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(uid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_46)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(uid) : -ENOSYS);

	    after_func = (stub_after_func_46)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, uid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getgid16' (47). */
asmlinkage static int
stub_syscall_47(void) {
	typedef int
		(*stub_func_47)(void);
	typedef int
		(*stub_before_func_47)(int* syscall_rc); 
	typedef int
		(*stub_after_func_47)(int syscall_rc);
	stub_func_47 orig_syscall_func;
	stub_before_func_47 before_func;
	stub_after_func_47 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[47];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_47)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_47)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_47)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'signal' (48). */
asmlinkage static int
stub_syscall_48(int sig, void* handler) {
	typedef int
		(*stub_func_48)(int sig, void* handler);
	typedef int
		(*stub_before_func_48)(int sig, void* handler, int* syscall_rc); 
	typedef int
		(*stub_after_func_48)(int syscall_rc, int sig, void* handler);
	stub_func_48 orig_syscall_func;
	stub_before_func_48 before_func;
	stub_after_func_48 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[48];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_48)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(sig, handler , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_48)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(sig, handler) : -ENOSYS);

	    after_func = (stub_after_func_48)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, sig, handler);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'geteuid16' (49). */
asmlinkage static int
stub_syscall_49(void) {
	typedef int
		(*stub_func_49)(void);
	typedef int
		(*stub_before_func_49)(int* syscall_rc); 
	typedef int
		(*stub_after_func_49)(int syscall_rc);
	stub_func_49 orig_syscall_func;
	stub_before_func_49 before_func;
	stub_after_func_49 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[49];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_49)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_49)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_49)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getegid16' (50). */
asmlinkage static int
stub_syscall_50(void) {
	typedef int
		(*stub_func_50)(void);
	typedef int
		(*stub_before_func_50)(int* syscall_rc); 
	typedef int
		(*stub_after_func_50)(int syscall_rc);
	stub_func_50 orig_syscall_func;
	stub_before_func_50 before_func;
	stub_after_func_50 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[50];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_50)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_50)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_50)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'acct' (51). */
asmlinkage static int
stub_syscall_51(const char* name) {
	typedef int
		(*stub_func_51)(const char* name);
	typedef int
		(*stub_before_func_51)(const char* name, int* syscall_rc); 
	typedef int
		(*stub_after_func_51)(int syscall_rc, const char* name);
	stub_func_51 orig_syscall_func;
	stub_before_func_51 before_func;
	stub_after_func_51 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[51];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_51)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(name , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_51)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(name) : -ENOSYS);

	    after_func = (stub_after_func_51)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, name);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'umount' (52). */
asmlinkage static int
stub_syscall_52(char* name, int flags) {
	typedef int
		(*stub_func_52)(char* name, int flags);
	typedef int
		(*stub_before_func_52)(char* name, int flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_52)(int syscall_rc, char* name, int flags);
	stub_func_52 orig_syscall_func;
	stub_before_func_52 before_func;
	stub_after_func_52 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[52];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_52)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(name, flags , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_52)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(name, flags) : -ENOSYS);

	    after_func = (stub_after_func_52)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, name, flags);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'ioctl' (54). */
asmlinkage static int
stub_syscall_54(unsigned int fd, unsigned int cmd, unsigned long arg) {
	typedef int
		(*stub_func_54)(unsigned int fd, unsigned int cmd, unsigned long arg);
	typedef int
		(*stub_before_func_54)(unsigned int fd, unsigned int cmd, unsigned long arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_54)(int syscall_rc, unsigned int fd, unsigned int cmd, unsigned long arg);
	stub_func_54 orig_syscall_func;
	stub_before_func_54 before_func;
	stub_after_func_54 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[54];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_54)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd, cmd, arg , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_54)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd, cmd, arg) : -ENOSYS);

	    after_func = (stub_after_func_54)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd, cmd, arg);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'fcntl' (55). */
asmlinkage static int
stub_syscall_55(unsigned int fd, unsigned int cmd, unsigned long arg) {
	typedef int
		(*stub_func_55)(unsigned int fd, unsigned int cmd, unsigned long arg);
	typedef int
		(*stub_before_func_55)(unsigned int fd, unsigned int cmd, unsigned long arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_55)(int syscall_rc, unsigned int fd, unsigned int cmd, unsigned long arg);
	stub_func_55 orig_syscall_func;
	stub_before_func_55 before_func;
	stub_after_func_55 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[55];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_55)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd, cmd, arg , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_55)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd, cmd, arg) : -ENOSYS);

	    after_func = (stub_after_func_55)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd, cmd, arg);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setpgid' (57). */
asmlinkage static int
stub_syscall_57(pid_t pid, pid_t pgid) {
	typedef int
		(*stub_func_57)(pid_t pid, pid_t pgid);
	typedef int
		(*stub_before_func_57)(pid_t pid, pid_t pgid, int* syscall_rc); 
	typedef int
		(*stub_after_func_57)(int syscall_rc, pid_t pid, pid_t pgid);
	stub_func_57 orig_syscall_func;
	stub_before_func_57 before_func;
	stub_after_func_57 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[57];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_57)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(pid, pgid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_57)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(pid, pgid) : -ENOSYS);

	    after_func = (stub_after_func_57)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, pid, pgid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'umask' (60). */
asmlinkage static int
stub_syscall_60(int mask) {
	typedef int
		(*stub_func_60)(int mask);
	typedef int
		(*stub_before_func_60)(int mask, int* syscall_rc); 
	typedef int
		(*stub_after_func_60)(int syscall_rc, int mask);
	stub_func_60 orig_syscall_func;
	stub_before_func_60 before_func;
	stub_after_func_60 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[60];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_60)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(mask , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_60)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(mask) : -ENOSYS);

	    after_func = (stub_after_func_60)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, mask);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'chroot' (61). */
asmlinkage static int
stub_syscall_61(const char* path) {
	typedef int
		(*stub_func_61)(const char* path);
	typedef int
		(*stub_before_func_61)(const char* path, int* syscall_rc); 
	typedef int
		(*stub_after_func_61)(int syscall_rc, const char* path);
	stub_func_61 orig_syscall_func;
	stub_before_func_61 before_func;
	stub_after_func_61 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[61];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_61)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(path , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_61)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(path) : -ENOSYS);

	    after_func = (stub_after_func_61)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, path);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'dup2' (63). */
asmlinkage static int
stub_syscall_63(int oldfd, int newfd) {
	typedef int
		(*stub_func_63)(int oldfd, int newfd);
	typedef int
		(*stub_before_func_63)(int oldfd, int newfd, int* syscall_rc); 
	typedef int
		(*stub_after_func_63)(int syscall_rc, int oldfd, int newfd);
	stub_func_63 orig_syscall_func;
	stub_before_func_63 before_func;
	stub_after_func_63 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[63];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_63)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldfd, newfd , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_63)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldfd, newfd) : -ENOSYS);

	    after_func = (stub_after_func_63)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldfd, newfd);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getppid' (64). */
asmlinkage static int
stub_syscall_64(void) {
	typedef int
		(*stub_func_64)(void);
	typedef int
		(*stub_before_func_64)(int* syscall_rc); 
	typedef int
		(*stub_after_func_64)(int syscall_rc);
	stub_func_64 orig_syscall_func;
	stub_before_func_64 before_func;
	stub_after_func_64 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[64];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_64)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_64)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_64)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getpgrp' (65). */
asmlinkage static int
stub_syscall_65(void) {
	typedef int
		(*stub_func_65)(void);
	typedef int
		(*stub_before_func_65)(int* syscall_rc); 
	typedef int
		(*stub_after_func_65)(int syscall_rc);
	stub_func_65 orig_syscall_func;
	stub_before_func_65 before_func;
	stub_after_func_65 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[65];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_65)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_65)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_65)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setsid' (66). */
asmlinkage static int
stub_syscall_66(void) {
	typedef int
		(*stub_func_66)(void);
	typedef int
		(*stub_before_func_66)(int* syscall_rc); 
	typedef int
		(*stub_after_func_66)(int syscall_rc);
	stub_func_66 orig_syscall_func;
	stub_before_func_66 before_func;
	stub_after_func_66 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[66];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_66)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_66)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_66)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'sigaction' (67). */
asmlinkage static int
stub_syscall_67(int sig, const struct old_sigaction* act, struct old_sigaction* oact) {
	typedef int
		(*stub_func_67)(int sig, const struct old_sigaction* act, struct old_sigaction* oact);
	typedef int
		(*stub_before_func_67)(int sig, const struct old_sigaction* act, struct old_sigaction* oact, int* syscall_rc); 
	typedef int
		(*stub_after_func_67)(int syscall_rc, int sig, const struct old_sigaction* act, struct old_sigaction* oact);
	stub_func_67 orig_syscall_func;
	stub_before_func_67 before_func;
	stub_after_func_67 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[67];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_67)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(sig, act, oact , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_67)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(sig, act, oact) : -ENOSYS);

	    after_func = (stub_after_func_67)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, sig, act, oact);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'sgetmask' (68). */
asmlinkage static int
stub_syscall_68(void) {
	typedef int
		(*stub_func_68)(void);
	typedef int
		(*stub_before_func_68)(int* syscall_rc); 
	typedef int
		(*stub_after_func_68)(int syscall_rc);
	stub_func_68 orig_syscall_func;
	stub_before_func_68 before_func;
	stub_after_func_68 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[68];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_68)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)( &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_68)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)() : -ENOSYS);

	    after_func = (stub_after_func_68)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval );
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'ssetmask' (69). */
asmlinkage static int
stub_syscall_69(int newmask) {
	typedef int
		(*stub_func_69)(int newmask);
	typedef int
		(*stub_before_func_69)(int newmask, int* syscall_rc); 
	typedef int
		(*stub_after_func_69)(int syscall_rc, int newmask);
	stub_func_69 orig_syscall_func;
	stub_before_func_69 before_func;
	stub_after_func_69 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[69];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_69)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(newmask , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_69)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(newmask) : -ENOSYS);

	    after_func = (stub_after_func_69)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, newmask);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setreuid16' (70). */
asmlinkage static int
stub_syscall_70(unsigned short ruid, unsigned short euid) {
	typedef int
		(*stub_func_70)(unsigned short ruid, unsigned short euid);
	typedef int
		(*stub_before_func_70)(unsigned short ruid, unsigned short euid, int* syscall_rc); 
	typedef int
		(*stub_after_func_70)(int syscall_rc, unsigned short ruid, unsigned short euid);
	stub_func_70 orig_syscall_func;
	stub_before_func_70 before_func;
	stub_after_func_70 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[70];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_70)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(ruid, euid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_70)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(ruid, euid) : -ENOSYS);

	    after_func = (stub_after_func_70)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, ruid, euid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setregid16' (71). */
asmlinkage static int
stub_syscall_71(unsigned short rgid, unsigned short egid) {
	typedef int
		(*stub_func_71)(unsigned short rgid, unsigned short egid);
	typedef int
		(*stub_before_func_71)(unsigned short rgid, unsigned short egid, int* syscall_rc); 
	typedef int
		(*stub_after_func_71)(int syscall_rc, unsigned short rgid, unsigned short egid);
	stub_func_71 orig_syscall_func;
	stub_before_func_71 before_func;
	stub_after_func_71 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[71];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_71)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(rgid, egid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_71)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(rgid, egid) : -ENOSYS);

	    after_func = (stub_after_func_71)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, rgid, egid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'sigsuspend' (72). */
asmlinkage static int
stub_syscall_72(int history0, int history1, unsigned long mask) {
	typedef int
		(*stub_func_72)(int history0, int history1, unsigned long mask);
	typedef int
		(*stub_before_func_72)(int history0, int history1, unsigned long mask, int* syscall_rc); 
	typedef int
		(*stub_after_func_72)(int syscall_rc, int history0, int history1, unsigned long mask);
	stub_func_72 orig_syscall_func;
	stub_before_func_72 before_func;
	stub_after_func_72 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[72];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_72)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(history0, history1, mask , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_72)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(history0, history1, mask) : -ENOSYS);

	    after_func = (stub_after_func_72)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, history0, history1, mask);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'sigpending' (73). */
asmlinkage static int
stub_syscall_73(unsigned long* set) {
	typedef int
		(*stub_func_73)(unsigned long* set);
	typedef int
		(*stub_before_func_73)(unsigned long* set, int* syscall_rc); 
	typedef int
		(*stub_after_func_73)(int syscall_rc, unsigned long* set);
	stub_func_73 orig_syscall_func;
	stub_before_func_73 before_func;
	stub_after_func_73 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[73];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_73)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(set , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_73)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(set) : -ENOSYS);

	    after_func = (stub_after_func_73)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, set);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'sethostname' (74). */
asmlinkage static int
stub_syscall_74(char* name, int len) {
	typedef int
		(*stub_func_74)(char* name, int len);
	typedef int
		(*stub_before_func_74)(char* name, int len, int* syscall_rc); 
	typedef int
		(*stub_after_func_74)(int syscall_rc, char* name, int len);
	stub_func_74 orig_syscall_func;
	stub_before_func_74 before_func;
	stub_after_func_74 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[74];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_74)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(name, len , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_74)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(name, len) : -ENOSYS);

	    after_func = (stub_after_func_74)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, name, len);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setrlimit' (75). */
asmlinkage static int
stub_syscall_75(int resource, struct rlimit* rlim) {
	typedef int
		(*stub_func_75)(int resource, struct rlimit* rlim);
	typedef int
		(*stub_before_func_75)(int resource, struct rlimit* rlim, int* syscall_rc); 
	typedef int
		(*stub_after_func_75)(int syscall_rc, int resource, struct rlimit* rlim);
	stub_func_75 orig_syscall_func;
	stub_before_func_75 before_func;
	stub_after_func_75 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[75];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_75)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(resource, rlim , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_75)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(resource, rlim) : -ENOSYS);

	    after_func = (stub_after_func_75)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, resource, rlim);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'old_getrlimit' (76). */
asmlinkage static int
stub_syscall_76(unsigned int resource, struct rlimit* rlim) {
	typedef int
		(*stub_func_76)(unsigned int resource, struct rlimit* rlim);
	typedef int
		(*stub_before_func_76)(unsigned int resource, struct rlimit* rlim, int* syscall_rc); 
	typedef int
		(*stub_after_func_76)(int syscall_rc, unsigned int resource, struct rlimit* rlim);
	stub_func_76 orig_syscall_func;
	stub_before_func_76 before_func;
	stub_after_func_76 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[76];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_76)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(resource, rlim , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_76)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(resource, rlim) : -ENOSYS);

	    after_func = (stub_after_func_76)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, resource, rlim);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'gettimeofday' (78). */
asmlinkage static int
stub_syscall_78(struct timeval* tv, struct timezone* tz) {
	typedef int
		(*stub_func_78)(struct timeval* tv, struct timezone* tz);
	typedef int
		(*stub_before_func_78)(struct timeval* tv, struct timezone* tz, int* syscall_rc); 
	typedef int
		(*stub_after_func_78)(int syscall_rc, struct timeval* tv, struct timezone* tz);
	stub_func_78 orig_syscall_func;
	stub_before_func_78 before_func;
	stub_after_func_78 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[78];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_78)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(tv, tz , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_78)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(tv, tz) : -ENOSYS);

	    after_func = (stub_after_func_78)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, tv, tz);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'settimeofday' (79). */
asmlinkage static int
stub_syscall_79(const struct timeval* tv, struct timezone* tz) {
	typedef int
		(*stub_func_79)(const struct timeval* tv, struct timezone* tz);
	typedef int
		(*stub_before_func_79)(const struct timeval* tv, struct timezone* tz, int* syscall_rc); 
	typedef int
		(*stub_after_func_79)(int syscall_rc, const struct timeval* tv, struct timezone* tz);
	stub_func_79 orig_syscall_func;
	stub_before_func_79 before_func;
	stub_after_func_79 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[79];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_79)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(tv, tz , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_79)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(tv, tz) : -ENOSYS);

	    after_func = (stub_after_func_79)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, tv, tz);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'symlink' (83). */
asmlinkage static int
stub_syscall_83(const char* oldpath, const char* newpath) {
	typedef int
		(*stub_func_83)(const char* oldpath, const char* newpath);
	typedef int
		(*stub_before_func_83)(const char* oldpath, const char* newpath, int* syscall_rc); 
	typedef int
		(*stub_after_func_83)(int syscall_rc, const char* oldpath, const char* newpath);
	stub_func_83 orig_syscall_func;
	stub_before_func_83 before_func;
	stub_after_func_83 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[83];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_83)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(oldpath, newpath , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_83)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(oldpath, newpath) : -ENOSYS);

	    after_func = (stub_after_func_83)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, oldpath, newpath);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'lstat' (84). */
asmlinkage static int
stub_syscall_84(char* filename, struct __old_kernel_stat* statbuf) {
	typedef int
		(*stub_func_84)(char* filename, struct __old_kernel_stat* statbuf);
	typedef int
		(*stub_before_func_84)(char* filename, struct __old_kernel_stat* statbuf, int* syscall_rc); 
	typedef int
		(*stub_after_func_84)(int syscall_rc, char* filename, struct __old_kernel_stat* statbuf);
	stub_func_84 orig_syscall_func;
	stub_before_func_84 before_func;
	stub_after_func_84 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[84];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_84)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(filename, statbuf , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_84)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(filename, statbuf) : -ENOSYS);

	    after_func = (stub_after_func_84)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, filename, statbuf);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'readink' (85). */
asmlinkage static int
stub_syscall_85(const char* path, char* buf, int bufsiz) {
	typedef int
		(*stub_func_85)(const char* path, char* buf, int bufsiz);
	typedef int
		(*stub_before_func_85)(const char* path, char* buf, int bufsiz, int* syscall_rc); 
	typedef int
		(*stub_after_func_85)(int syscall_rc, const char* path, char* buf, int bufsiz);
	stub_func_85 orig_syscall_func;
	stub_before_func_85 before_func;
	stub_after_func_85 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[85];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_85)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(path, buf, bufsiz , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_85)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(path, buf, bufsiz) : -ENOSYS);

	    after_func = (stub_after_func_85)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, path, buf, bufsiz);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'uselib' (86). */
asmlinkage static int
stub_syscall_86(const char* library) {
	typedef int
		(*stub_func_86)(const char* library);
	typedef int
		(*stub_before_func_86)(const char* library, int* syscall_rc); 
	typedef int
		(*stub_after_func_86)(int syscall_rc, const char* library);
	stub_func_86 orig_syscall_func;
	stub_before_func_86 before_func;
	stub_after_func_86 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[86];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_86)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(library , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_86)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(library) : -ENOSYS);

	    after_func = (stub_after_func_86)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, library);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'swapon' (87). */
asmlinkage static int
stub_syscall_87(const char* specialfile, int swap_flags) {
	typedef int
		(*stub_func_87)(const char* specialfile, int swap_flags);
	typedef int
		(*stub_before_func_87)(const char* specialfile, int swap_flags, int* syscall_rc); 
	typedef int
		(*stub_after_func_87)(int syscall_rc, const char* specialfile, int swap_flags);
	stub_func_87 orig_syscall_func;
	stub_before_func_87 before_func;
	stub_after_func_87 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[87];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_87)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(specialfile, swap_flags , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_87)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(specialfile, swap_flags) : -ENOSYS);

	    after_func = (stub_after_func_87)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, specialfile, swap_flags);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'reboot' (88). */
asmlinkage static int
stub_syscall_88(int magic1, int magic2, unsigned int cmd, void* arg) {
	typedef int
		(*stub_func_88)(int magic1, int magic2, unsigned int cmd, void* arg);
	typedef int
		(*stub_before_func_88)(int magic1, int magic2, unsigned int cmd, void* arg, int* syscall_rc); 
	typedef int
		(*stub_after_func_88)(int syscall_rc, int magic1, int magic2, unsigned int cmd, void* arg);
	stub_func_88 orig_syscall_func;
	stub_before_func_88 before_func;
	stub_after_func_88 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[88];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_88)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(magic1, magic2, cmd, arg , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_88)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(magic1, magic2, cmd, arg) : -ENOSYS);

	    after_func = (stub_after_func_88)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, magic1, magic2, cmd, arg);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'munmap' (91). */
asmlinkage static int
stub_syscall_91(unsigned long addr, size_t len) {
	typedef int
		(*stub_func_91)(unsigned long addr, size_t len);
	typedef int
		(*stub_before_func_91)(unsigned long addr, size_t len, int* syscall_rc); 
	typedef int
		(*stub_after_func_91)(int syscall_rc, unsigned long addr, size_t len);
	stub_func_91 orig_syscall_func;
	stub_before_func_91 before_func;
	stub_after_func_91 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[91];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_91)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(addr, len , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_91)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(addr, len) : -ENOSYS);

	    after_func = (stub_after_func_91)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, addr, len);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'truncate' (92). */
asmlinkage static int
stub_syscall_92(const char* path, unsigned long length) {
	typedef int
		(*stub_func_92)(const char* path, unsigned long length);
	typedef int
		(*stub_before_func_92)(const char* path, unsigned long length, int* syscall_rc); 
	typedef int
		(*stub_after_func_92)(int syscall_rc, const char* path, unsigned long length);
	stub_func_92 orig_syscall_func;
	stub_before_func_92 before_func;
	stub_after_func_92 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[92];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_92)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(path, length , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_92)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(path, length) : -ENOSYS);

	    after_func = (stub_after_func_92)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, path, length);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'ftruncate' (93). */
asmlinkage static int
stub_syscall_93(unsigned int fd, unsigned long length) {
	typedef int
		(*stub_func_93)(unsigned int fd, unsigned long length);
	typedef int
		(*stub_before_func_93)(unsigned int fd, unsigned long length, int* syscall_rc); 
	typedef int
		(*stub_after_func_93)(int syscall_rc, unsigned int fd, unsigned long length);
	stub_func_93 orig_syscall_func;
	stub_before_func_93 before_func;
	stub_after_func_93 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[93];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_93)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd, length , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_93)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd, length) : -ENOSYS);

	    after_func = (stub_after_func_93)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd, length);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'fchmod' (94). */
asmlinkage static int
stub_syscall_94(unsigned int fd, mode_t mode) {
	typedef int
		(*stub_func_94)(unsigned int fd, mode_t mode);
	typedef int
		(*stub_before_func_94)(unsigned int fd, mode_t mode, int* syscall_rc); 
	typedef int
		(*stub_after_func_94)(int syscall_rc, unsigned int fd, mode_t mode);
	stub_func_94 orig_syscall_func;
	stub_before_func_94 before_func;
	stub_after_func_94 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[94];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_94)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd, mode , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_94)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd, mode) : -ENOSYS);

	    after_func = (stub_after_func_94)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd, mode);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'fchown16:' (95). */
asmlinkage static int
stub_syscall_95(unsigned int fd, unsigned short user, unsigned short group) {
	typedef int
		(*stub_func_95)(unsigned int fd, unsigned short user, unsigned short group);
	typedef int
		(*stub_before_func_95)(unsigned int fd, unsigned short user, unsigned short group, int* syscall_rc); 
	typedef int
		(*stub_after_func_95)(int syscall_rc, unsigned int fd, unsigned short user, unsigned short group);
	stub_func_95 orig_syscall_func;
	stub_before_func_95 before_func;
	stub_after_func_95 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[95];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_95)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(fd, user, group , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_95)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(fd, user, group) : -ENOSYS);

	    after_func = (stub_after_func_95)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, fd, user, group);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'getpriority' (96). */
asmlinkage static int
stub_syscall_96(int which, int who) {
	typedef int
		(*stub_func_96)(int which, int who);
	typedef int
		(*stub_before_func_96)(int which, int who, int* syscall_rc); 
	typedef int
		(*stub_after_func_96)(int syscall_rc, int which, int who);
	stub_func_96 orig_syscall_func;
	stub_before_func_96 before_func;
	stub_after_func_96 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[96];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_96)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(which, who , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_96)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(which, who) : -ENOSYS);

	    after_func = (stub_after_func_96)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, which, who);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setpriority' (97). */
asmlinkage static int
stub_syscall_97(int which, int who, int pro) {
	typedef int
		(*stub_func_97)(int which, int who, int pro);
	typedef int
		(*stub_before_func_97)(int which, int who, int pro, int* syscall_rc); 
	typedef int
		(*stub_after_func_97)(int syscall_rc, int which, int who, int pro);
	stub_func_97 orig_syscall_func;
	stub_before_func_97 before_func;
	stub_after_func_97 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[97];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_97)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(which, who, pro , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_97)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(which, who, pro) : -ENOSYS);

	    after_func = (stub_after_func_97)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, which, who, pro);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'ioperm' (101). */
asmlinkage static int
stub_syscall_101(unsigned long from, unsigned long num, int on) {
	typedef int
		(*stub_func_101)(unsigned long from, unsigned long num, int on);
	typedef int
		(*stub_before_func_101)(unsigned long from, unsigned long num, int on, int* syscall_rc); 
	typedef int
		(*stub_after_func_101)(int syscall_rc, unsigned long from, unsigned long num, int on);
	stub_func_101 orig_syscall_func;
	stub_before_func_101 before_func;
	stub_after_func_101 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[101];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_101)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(from, num, on , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_101)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(from, num, on) : -ENOSYS);

	    after_func = (stub_after_func_101)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, from, num, on);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'syslog' (103). */
asmlinkage static int
stub_syscall_103(int type, char* buf, int len) {
	typedef int
		(*stub_func_103)(int type, char* buf, int len);
	typedef int
		(*stub_before_func_103)(int type, char* buf, int len, int* syscall_rc); 
	typedef int
		(*stub_after_func_103)(int syscall_rc, int type, char* buf, int len);
	stub_func_103 orig_syscall_func;
	stub_before_func_103 before_func;
	stub_after_func_103 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[103];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_103)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(type, buf, len , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_103)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(type, buf, len) : -ENOSYS);

	    after_func = (stub_after_func_103)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, type, buf, len);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'iopl' (110). */
asmlinkage static int
stub_syscall_110(unsigned long unused) {
	typedef int
		(*stub_func_110)(unsigned long unused);
	typedef int
		(*stub_before_func_110)(unsigned long unused, int* syscall_rc); 
	typedef int
		(*stub_after_func_110)(int syscall_rc, unsigned long unused);
	stub_func_110 orig_syscall_func;
	stub_before_func_110 before_func;
	stub_after_func_110 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[110];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_110)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(unused , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_110)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(unused) : -ENOSYS);

	    after_func = (stub_after_func_110)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, unused);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'setuid' (213). */
asmlinkage static int
stub_syscall_213(uid_t uid) {
	typedef int
		(*stub_func_213)(uid_t uid);
	typedef int
		(*stub_before_func_213)(uid_t uid, int* syscall_rc); 
	typedef int
		(*stub_after_func_213)(int syscall_rc, uid_t uid);
	stub_func_213 orig_syscall_func;
	stub_before_func_213 before_func;
	stub_after_func_213 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[213];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_213)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(uid , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_213)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(uid) : -ENOSYS);

	    after_func = (stub_after_func_213)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, uid);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}

/* stub function for syscall 'socketcall' (102). */
asmlinkage static int
stub_syscall_102(int call, unsigned long* args) {
	typedef int
		(*stub_func_102)(int call, unsigned long* args);
	typedef int
		(*stub_before_func_102)(int call, unsigned long* args, int* syscall_rc); 
	typedef int
		(*stub_after_func_102)(int syscall_rc, int call, unsigned long* args);
	stub_func_102 orig_syscall_func;
	stub_before_func_102 before_func;
	stub_after_func_102 after_func;
	sct_syscall_retval_policy retval; /* after calling the before */
					  /* func, should we continue */
					  /* and call the original    */
					  /* syscall?                 */
	int fake_syscall_retval = 0;  /* the 'before' function will */
			              /* fill this variable for us  */
				      /* if it wants to 'fail' the  */
				      /* syscall                    */
	int orig_syscall_retval = 0;  /* the original syscall retval */

	struct syscall_hijack_data* hdata = &hijack_data[102];

	down(&hdata->sem);
	hdata->invocation_ref_count++;
	up(&hdata->sem);
	before_func = (stub_before_func_102)hdata->before_hijack_func;

	retval = (before_func
		    ? (*before_func)(call, args , &fake_syscall_retval)
		    : SCT_USE_ORIG_RETVAL);

	/* invoke the original syscall, if the hijack function returned 0. */
	if (retval == SCT_USE_ORIG_RETVAL) {
	    orig_syscall_func = (stub_func_102)hdata->orig_syscall;
	    orig_syscall_retval = (orig_syscall_func ? (*orig_syscall_func)(call, args) : -ENOSYS);

	    after_func = (stub_after_func_102)hdata->after_hijack_func;
	    if (after_func)
		(*after_func)(orig_syscall_retval, call, args);
	}

	/* calling unconditional down() is never a good idea but we   */
	/* *must* grab this lock and lower the ref count, or we risk  */
	/* having it too high by one, leading to being unable to      */
	/* unload the module. also, none of the other holders of this */
	/* lock can block, so down() should be ok.                    */
	down(&hdata->sem);
	if (--hdata->invocation_ref_count == 0 &&
				hdata->defered_release_flag == 1) {
	    /* we couldn't reduce the module's use count when the syscall  */
	    /* was originally released (as marked by the 'defered' flag) - */
	    /* so we do so now.                                            */
	    MOD_DEC_USE_COUNT;
	    hdata->defered_release_flag = 0;
	}
	up(&hdata->sem);

	return (retval == SCT_USE_ORIG_RETVAL ? orig_syscall_retval : fake_syscall_retval);
}


/* pointers to stub functions - to be used */
/* when hijacking system calls.            */
func_ptr stub_functions[] = {
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_3,
	(func_ptr)stub_syscall_4,
	(func_ptr)stub_syscall_5,
	(func_ptr)stub_syscall_6,
	(func_ptr)stub_syscall_7,
	(func_ptr)stub_syscall_8,
	(func_ptr)stub_syscall_9,
	(func_ptr)stub_syscall_10,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_12,
	(func_ptr)stub_syscall_13,
	(func_ptr)stub_syscall_14,
	(func_ptr)stub_syscall_15,
	(func_ptr)stub_syscall_16,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_18,
	(func_ptr)stub_syscall_19,
	(func_ptr)stub_syscall_20,
	(func_ptr)stub_syscall_21,
	(func_ptr)stub_syscall_22,
	(func_ptr)stub_syscall_23,
	(func_ptr)stub_syscall_24,
	(func_ptr)stub_syscall_25,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_27,
	(func_ptr)stub_syscall_28,
	(func_ptr)stub_syscall_29,
	(func_ptr)stub_syscall_30,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_33,
	(func_ptr)stub_syscall_34,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_36,
	(func_ptr)stub_syscall_37,
	(func_ptr)stub_syscall_38,
	(func_ptr)stub_syscall_39,
	(func_ptr)stub_syscall_40,
	(func_ptr)stub_syscall_41,
	(func_ptr)stub_syscall_42,
	(func_ptr)stub_syscall_43,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_45,
	(func_ptr)stub_syscall_46,
	(func_ptr)stub_syscall_47,
	(func_ptr)stub_syscall_48,
	(func_ptr)stub_syscall_49,
	(func_ptr)stub_syscall_50,
	(func_ptr)stub_syscall_51,
	(func_ptr)stub_syscall_52,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_54,
	(func_ptr)stub_syscall_55,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_57,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_60,
	(func_ptr)stub_syscall_61,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_63,
	(func_ptr)stub_syscall_64,
	(func_ptr)stub_syscall_65,
	(func_ptr)stub_syscall_66,
	(func_ptr)stub_syscall_67,
	(func_ptr)stub_syscall_68,
	(func_ptr)stub_syscall_69,
	(func_ptr)stub_syscall_70,
	(func_ptr)stub_syscall_71,
	(func_ptr)stub_syscall_72,
	(func_ptr)stub_syscall_73,
	(func_ptr)stub_syscall_74,
	(func_ptr)stub_syscall_75,
	(func_ptr)stub_syscall_76,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_78,
	(func_ptr)stub_syscall_79,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_83,
	(func_ptr)stub_syscall_84,
	(func_ptr)stub_syscall_85,
	(func_ptr)stub_syscall_86,
	(func_ptr)stub_syscall_87,
	(func_ptr)stub_syscall_88,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_91,
	(func_ptr)stub_syscall_92,
	(func_ptr)stub_syscall_93,
	(func_ptr)stub_syscall_94,
	(func_ptr)stub_syscall_95,
	(func_ptr)stub_syscall_96,
	(func_ptr)stub_syscall_97,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_101,
	(func_ptr)stub_syscall_102,
	(func_ptr)stub_syscall_103,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_110,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)stub_syscall_213,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
	(func_ptr)NULL,
};
